# Generated by sila2.code_generator; sila2.__version__: 0.9.2

from typing import Optional
from uuid import UUID

from sila2.server import SilaServer

from .feature_implementations.cancelcontroller_impl import CancelControllerImpl
from .feature_implementations.connectionconfigurationservice_impl import ConnectionConfigurationServiceImpl
from .feature_implementations.dissolvedoxygencontroller_impl import DissolvedOxygenControllerImpl
from .feature_implementations.pausecontroller_impl import PauseControllerImpl
from .feature_implementations.phcontroller_impl import PHControllerImpl
from .feature_implementations.simulationcontroller_impl import SimulationControllerImpl
from .feature_implementations.stirrercontroller_impl import StirrerControllerImpl
from .feature_implementations.temperaturecontroller_impl import TemperatureControllerImpl
from .feature_implementations.turbidityprovider_impl import TurbidityProviderImpl
from .generated.cancelcontroller import CancelControllerFeature
from .generated.connectionconfigurationservice import ConnectionConfigurationServiceFeature
from .generated.dissolvedoxygencontroller import DissolvedOxygenControllerFeature
from .generated.pausecontroller import PauseControllerFeature
from .generated.phcontroller import PHControllerFeature
from .generated.simulationcontroller import SimulationControllerFeature
from .generated.stirrercontroller import StirrerControllerFeature
from .generated.temperaturecontroller import TemperatureControllerFeature
from .generated.turbidityprovider import TurbidityProviderFeature


class Server(SilaServer):
    def __init__(self, server_uuid: Optional[UUID] = None):
        # TODO: fill in your server information
        super().__init__(
            server_name="TODO",
            server_type="TODO",
            server_version="0.1",
            server_description="TODO",
            server_vendor_url="https://gitlab.com/SiLA2/sila_python",
            server_uuid=server_uuid,
        )

        self.cancelcontroller = CancelControllerImpl(self)
        self.set_feature_implementation(CancelControllerFeature, self.cancelcontroller)

        self.connectionconfigurationservice = ConnectionConfigurationServiceImpl(self)
        self.set_feature_implementation(ConnectionConfigurationServiceFeature, self.connectionconfigurationservice)

        self.dissolvedoxygencontroller = DissolvedOxygenControllerImpl(self)
        self.set_feature_implementation(DissolvedOxygenControllerFeature, self.dissolvedoxygencontroller)

        self.pausecontroller = PauseControllerImpl(self)
        self.set_feature_implementation(PauseControllerFeature, self.pausecontroller)

        self.simulationcontroller = SimulationControllerImpl(self)
        self.set_feature_implementation(SimulationControllerFeature, self.simulationcontroller)

        self.stirrercontroller = StirrerControllerImpl(self)
        self.set_feature_implementation(StirrerControllerFeature, self.stirrercontroller)

        self.temperaturecontroller = TemperatureControllerImpl(self)
        self.set_feature_implementation(TemperatureControllerFeature, self.temperaturecontroller)

        self.turbidityprovider = TurbidityProviderImpl(self)
        self.set_feature_implementation(TurbidityProviderFeature, self.turbidityprovider)

        self.phcontroller = PHControllerImpl(self)
        self.set_feature_implementation(PHControllerFeature, self.phcontroller)
